/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

(function(window) {

function createCheckerZusatzgeschwindigkeit(deltaX, deltaY) {
    return function() {
        if (!this.pfeile.length)
            return 'Zeichne zuerst die gesuchte Geschwindigkeit ein…';
        const lastPfeil = this.pfeile[this.pfeile.length - 1];
        if (lastPfeil.x1 != 50 || lastPfeil.y1 != 30)
            return 'Der Fußpunkt der resultierenden Kraft muss die Kugelmitte sein.';
//console.log({ x: lastPfeil.x1, y: lastPfeil.y1, deltaX: lastPfeil.deltaX, deltaY: lastPfeil.deltaY });return true;
        return (lastPfeil.deltaX == deltaX && lastPfeil.deltaY == deltaY);
    }
}

const LEVELS = [
    {
        "task": "<p>Alle gerade auf die Kugel einwirkenden Kräfte sind eingezeichnet.</p><p>Ergänze die resultierende Kraft. Du kannst Hilfspfeile einzeichnen, der zuletzt eingezeichnete Pfeil muss aber die resultierende Kraft darstellen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario1.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerZusatzgeschwindigkeit(-5, 20)
    },
    {
        "task": "<p>Alle gerade auf die Kugel einwirkenden Kräfte sind eingezeichnet.</p><p>Ergänze die resultierende Kraft. Du kannst Hilfspfeile einzeichnen, der zuletzt eingezeichnete Pfeil muss aber die resultierende Kraft darstellen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario2.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerZusatzgeschwindigkeit(-5, -10)
    },
    {
        "task": "<p>Alle gerade auf die Kugel einwirkenden Kräfte sind eingezeichnet.</p><p>Ergänze die resultierende Kraft. Du kannst Hilfspfeile einzeichnen, der zuletzt eingezeichnete Pfeil muss aber die resultierende Kraft darstellen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario3.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerZusatzgeschwindigkeit(0, 10)
    },
    {
        "task": "<p>Alle gerade auf die Kugel einwirkenden Kräfte sind eingezeichnet.</p><p>Ergänze die resultierende Kraft. Du kannst Hilfspfeile einzeichnen, der zuletzt eingezeichnete Pfeil muss aber die resultierende Kraft darstellen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario4.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerZusatzgeschwindigkeit(-5, -30)
    },
    {
        "task": "<p>Alle gerade auf die Kugel einwirkenden Kräfte sind eingezeichnet.</p><p>Ergänze die resultierende Kraft. Du kannst Hilfspfeile einzeichnen, der zuletzt eingezeichnete Pfeil muss aber die resultierende Kraft darstellen.</p>",
        "shadows": [
            { type: 'image', src: 'szenario5.svg', x: 0, y: 0, width: 100, height: 60 }
        ],
        "style": '#layer1 > path {stroke:#888a85} #layer1 > path:last-child {stroke:#c00}',
        "check": createCheckerZusatzgeschwindigkeit(0, 15)
    }
];

window.karokonstruktionTask = {
    levels: LEVELS
};
})(window);
